local BS = AceLibrary("Babble-Spell-2.2");

function DrDamage:MageData()

	local MageTable = {

		spellInfo = { 
		
			[BS["Pyroblast"]] = {
						[0] = { School = "Fire", castTime = 6, canCrit = true, Ignite = true, eDuration=12, sTicks = 3, bonusFactor = 1.15, hybridDotFactor = 0.25, BaseIncrease = true, Downrank = 2, },
						[1] = { 141, 187, 7, 8, hybridDotDmg = 56, spellLevel = 20, maxLevel = 23, },
						[2] = { 180, 236, 13, 14, hybridDotDmg = 72, spellLevel = 24, maxLevel = 29, },
						[3] = { 255, 327, 15, 16, hybridDotDmg = 96, spellLevel = 30, maxLevel = 35, },
						[4] = { 329, 419, 18, 18, hybridDotDmg = 124, spellLevel = 36, maxLevel = 41, },
						[5] = { 407, 515, 20, 21, hybridDotDmg=156, spellLevel = 42, maxLevel = 47, },
						[6] = { 503, 631, 22, 23, hybridDotDmg=188, spellLevel = 48, maxLevel = 53, },
						[7] = { 600, 750, 25, 26, hybridDotDmg=228, spellLevel = 54, maxLevel = 59, },
						[8] = { 708, 898, 27, 28, hybridDotDmg=268, spellLevel = 60, maxLevel = 65, },
						[9] = { 846, 1074, 20, 20, hybridDotDmg=312, spellLevel = 66, maxLevel = 69, },
						[10] = { 939, 1191, 0, 0, hybridDotDmg=356, spellLevel = 70, maxLevel = 70, },
						--Downrank: +2 -> guess
			},
			[BS["Fireball"]] = {
						[0] = { School = "Fire", canCrit = true, castTime = 3.5, CastMod = 0.1, CastModDmg = 0.02, Ignite = true, eDuration=8, sTicks = 2, BaseIncrease = true, Downrank = 2, },
						[1] = { 14, 22, 2, 3, extraDotDmg= 2, spellLevel = 1, maxLevel = 5, castTime = 1.5, eDuration = 4, },
						[2] = { 31, 45, 3, 4, extraDotDmg= 3, spellLevel = 6, maxLevel = 11, castTime = 2, eDuration = 6, },
						[3] = { 53, 73, 4, 4, extraDotDmg= 6, spellLevel = 12, maxLevel = 17, castTime = 2.5, eDuration = 6, },
						[4] = { 84, 116, 5, 6, extraDotDmg= 12, spellLevel = 18, maxLevel = 23, castTime = 3, },
						[5] = { 139, 187, 6, 8, extraDotDmg= 20, spellLevel = 24, maxLevel = 29, },
						[6] = { 199, 265, 8, 9, extraDotDmg= 28, spellLevel = 30, maxLevel = 35, },
						[7] = { 255, 335, 11, 10, extraDotDmg= 32, spellLevel = 36, maxLevel = 41, },
						[8] = { 318, 414, 10, 11, extraDotDmg=40, spellLevel = 42, maxLevel = 47, },
						[9] = { 392, 506, 12, 12, extraDotDmg=52, spellLevel = 48, maxLevel = 53, },
						[10] = { 475, 609, 13, 14, extraDotDmg=60, spellLevel = 54, maxLevel = 59, },
						[11] = { 561, 715, 14, 15, extraDotDmg=72, spellLevel = 60, maxLevel = 64, Downrank = 3 },
						[12] = { 596, 760, 15, 16, extraDotDmg=76, spellLevel = 60, maxLevel = 65, },
						[13] = { 633, 805, 16, 16, extraDotDmg=84, spellLevel = 66, maxLevel = 70, },
						--Downrank: +2 -> guess
			},
			[BS["Scorch"]] = {
						[0] = { School = "Fire", canCrit = true,  Ignite = true, BaseIncrease = true, Downrank = 2, },
						[1] = { 53, 65, 3, 4, spellLevel = 22, maxLevel = 27, },
						[2] = { 77, 93, 4, 5, spellLevel = 28, maxLevel = 33, },
						[3] = { 100, 120, 5, 6, spellLevel = 34, maxLevel = 39, },
						[4] = { 133, 159, 6, 6, spellLevel = 40, maxLevel = 45, },
						[5] = { 162, 192, 6, 7, spellLevel = 46, maxLevel = 51, },
						[6] = { 200, 239, 7, 8, spellLevel = 52, maxLevel = 57, },
						[7] = { 233, 275, 8, 9, spellLevel = 58, maxLevel = 63, },
						[8] = { 269, 317, 9, 10, spellLevel = 64, maxLevel = 69, },
						[9] = { 305, 361, 0, 0, spellLevel = 70, maxLevel = 70, },
						--Downrank: +2 -> guess
			},
			[BS["Fire Blast"]] = {
						[0] = { School = "Fire", Instant = true, canCrit = true, Ignite = true, Cooldown = 8, BaseIncrease = true, },
						[1] = { 24, 32, 3, 3, spellLevel = 6, maxLevel = 13, },
						[2] = { 57, 71, 5, 5, spellLevel = 14, maxLevel = 21, },
						[3] = { 103, 127, 7, 7, spellLevel = 22, maxLevel = 29, },
						[4] = { 168, 202, 9, 9, spellLevel = 30, maxLevel = 37, },
						[5] = { 242, 290, 11, 11, spellLevel = 38, maxLevel = 45, },
						[6] = { 332, 394, 13, 13, spellLevel = 46, maxLevel = 53, },
						[7] = { 431, 509, 15, 15, spellLevel = 54, maxLevel = 60, },
						[8] = { 539, 637, 16, 18, spellLevel = 61, maxLevel = 69, },
						[9] = { 664, 786, 0, 0, spellLevel = 70, maxLevel = 70, },
			},				
			[BS["Blast Wave"]] = {
						[0] = { School = "Fire", Instant = true, canCrit = true, sFactor=0.90 * 1/2, Ignite = true, Cooldown = 45, BaseIncrease = true, Downrank = 2, },
						[1] = { 154, 186, 6, 6, spellLevel = 30, maxLevel = 35, },
						[2] = { 201, 241, 7, 8, spellLevel = 36, maxLevel = 43, },
						[3] = { 277, 329, 8, 9, spellLevel = 44, maxLevel = 51, },
						[4] = { 365, 433, 9, 10, spellLevel = 52, maxLevel = 59, },
						[5] = { 462, 544, 11, 12, spellLevel = 60, maxLevel = 64, },
						[6] = { 533, 627, 10, 11, spellLevel = 65, maxLevel = 69, },
						[7] = { 616, 724, 0, 0, spellLevel = 70, maxLevel = 70, },
						--Downrank: +2 -> guess
			},
			[BS["Dragon's Breath"]] = {
						[0] = { School = "Fire", Instant = true, canCrit = true, sFactor= 0.90 * 1/2, Ignite = true, Cooldown = 20, BaseIncrease = true, Downrank = 2 },
						[1] = { 370, 430, 12, 12, spellLevel = 50, maxLevel = 55, },
						[2] = { 454, 526, 9, 10, spellLevel = 56, maxLevel = 63, },
						[3] = { 574, 666, 10, 11, spellLevel = 64, maxLevel = 69, },
						[4] = { 680, 790, 0, 0, spellLevel = 70, maxLevel = 70, },
						--Downrank: +2 -> guess
			},				
			[BS["Flamestrike"]] = {
						[0] = { School = "Fire", castTime = 3, canCrit = true, Ignite = true, eDuration = 8, sTicks = 2, sFactor = 1/2, hybridFactor = 417/757, hybridDotFactor = 0.83, BaseIncrease = true, },
						[1] = { 52, 68, 3, 3, hybridDotDmg = 48, spellLevel = 16, maxLevel = 23, },
						[2] = { 96, 122, 4, 4, hybridDotDmg = 88, spellLevel = 24, maxLevel = 31, },
						[3] = { 154, 192, 5, 5, hybridDotDmg = 140, spellLevel = 32, maxLevel = 39, },
						[4] = { 220, 272, 6, 7, hybridDotDmg = 192, spellLevel = 40, maxLevel = 47, },
						[5] = { 291, 359, 7, 8, hybridDotDmg = 264, spellLevel = 48, maxLevel = 55, },
						[6] = { 375, 459, 8, 9, hybridDotDmg = 340, spellLevel = 56, maxLevel = 63, },
						[7] = { 471, 575, 9, 10, hybridDotDmg = 424, spellLevel = 64, maxLevel = 70, },
			},				
			[BS["Frostbolt"]] = {
						[0] = { School = "Frost", castTime = 3, canCrit = true, CastMod = 0.1, CastModDmg = 0.02, sFactor = 0.95, BaseIncrease = true, Downrank = 2, },
						[1] = { 18, 20, 2, 2, spellLevel = 4, maxLevel = 7, castTime = 1.5, },
						[2] = { 31, 35, 2, 3, spellLevel = 8, maxLevel = 13, castTime = 1.8, },
						[3] = { 51, 57, 3, 4, spellLevel = 14, maxLevel = 19, castTime = 2.2, },
						[4] = { 74, 82, 4, 5, spellLevel = 20, maxLevel = 25, castTime = 2.6, },
						[5] = { 126, 138, 6, 6, spellLevel = 26, maxLevel = 31, },
						[6] = { 174, 190, 6, 7, spellLevel = 32, maxLevel = 37, },
						[7] = { 227, 247, 8, 8, spellLevel = 38, maxLevel = 43, },
						[8] = { 292, 316, 9, 10, spellLevel = 44, maxLevel = 49, },
						[9] = { 353, 383, 10, 11, spellLevel = 50, maxLevel = 55, },
						[10] = { 429, 463, 11, 12, spellLevel = 56, maxLevel = 59, Downrank = 4 },
						[11] = { 515, 555, 12, 13, spellLevel = 60, maxLevel = 62, Downrank = 5 },
						[12] = { 536, 578, 12, 13, spellLevel = 63, maxLevel = 68, },
						[13] = { 597, 643, 3, 4, spellLevel = 69, maxLevel = 70, }, 
			},
			--Tested
			[BS["Blizzard"]] = {
						[0] = { School = "Frost", castTime = 8, sFactor = 0.836 * 1/2, BaseIncrease = true, sTicks = 1, },
						[1] = { 200, 200, 0, 8, spellLevel = 20, maxLevel = 27, },
						[2] = { 352, 352, 8, 8, spellLevel = 28, maxLevel = 35, },
						[3] = { 520, 520, 8, 8, spellLevel = 36, maxLevel = 43, },
						[4] = { 720, 720, 8, 16, spellLevel = 44, maxLevel = 51, },
						[5] = { 936, 936, 8, 16, spellLevel = 52, maxLevel = 59, },
						[6] = { 1192, 1192, 16, 16, spellLevel = 60, maxLevel = 67, },
						[7] = { 1472, 1472, 0, 8, spellLevel = 68, maxLevel = 70, },
			},
			--Empiric tests suggests: 1.5/3.5 * 1/2 * 0.8
			[BS["Cone of Cold"]] = {
						[0] = { School = "Frost", Instant = true, canCrit = true, sFactor= 0.80 * 1/2, Cooldown = 10, BaseIncrease = true, },
						[1] = { 98, 108, 4, 4, spellLevel = 26, maxLevel = 33, },
						[2] = { 146, 160, 5, 5, spellLevel = 34, maxLevel = 41, },
						[3] = { 203, 223, 6, 6, spellLevel = 42, maxLevel = 49, },
						[4] = { 264, 290, 6, 7, spellLevel = 50, maxLevel = 57, },
						[5] = { 335, 365, 7, 8, spellLevel = 58, maxLevel = 65, },
						[6] = { 410, 448, 8, 9, spellLevel = 66, maxLevel = 70, },
			},
			[BS["Frost Nova"]] = {
						[0] = { School = "Frost", Instant = true, canCrit = true, sFactor= 0.13 * 1/2, Cooldown = 25, BaseIncrease = true, Downrank = -8 },
						[1] = { 19, 21, 2, 3,  spellLevel = 10, maxLevel = 25, },
						[2] = { 33, 37, 2, 3,  spellLevel = 26, maxLevel = 39, },
						[3] = { 47, 53, 7, 8, spellLevel = 40, maxLevel = 53, },
						[4] = { 71, 79, 2, 3, spellLevel = 54, maxLevel = 67, },
						[5] = { 99, 111, 1, 2, spellLevel = 68, maxLevel = 70, },
			},
			[BS["Ice Lance"]] = {
						[0] = { School = "Frost", Instant = true, canCrit = true, sFactor = 1/3, BaseIncrease = true, },
						[1] = { 161, 187, 9, 13, spellLevel = 66, maxLevel = 70, },
			},			
			[BS["Ice Barrier"]] = {
						[0] = { School = "Frost", Instant = true, Cooldown = 10, bonusFactor = 0.1, NoSchoolTalents = true, NoDPS = true, NoDoom = true, Unresistable = true, NoBuffs = true, NoDebuffs = true, NoDPM = true, BaseIncrease = true, Downrank = 2, },
						[1] = { 438, 438, 16, 16,  spellLevel = 40, maxLevel = 45, },
						[2] = { 549, 549, 19, 19, spellLevel = 46, maxLevel = 51, },
						[3] = { 678, 678, 21, 21, spellLevel = 52, maxLevel = 57, },
						[4] = { 818, 818, 24, 24, spellLevel = 58, maxLevel = 63, },
						[5] = { 977, 977, 26, 26, spellLevel = 64, maxLevel = 69, },
						[6] = { 1175, 1175, 0, 0, spellLevel = 70, maxLevel = 70, },
			},
			[BS["Arcane Missiles"]] = {
						[0] = { School = "Arcane", canCrit = true, castTime = 5, sHits = 5, BaseIncrease = true, },
						[1] = { 24, 24, 1, 2, spellLevel = 8, maxLevel = 15, castTime = 3, sHits = 3, },
						[2] = { 36, 36, 1, 2, spellLevel = 16, maxLevel = 23, castTime = 4, sHits = 4, },
						[3] = { 56, 56, 2, 2, spellLevel = 24, maxLevel = 31, },
						[4] = { 83, 83, 2, 3, spellLevel = 32, maxLevel = 39, },
						[5] = { 115, 115, 2, 3, spellLevel = 40, maxLevel = 47, },
						[6] = { 151, 151, 3, 4, spellLevel = 48, maxLevel = 55, },
						[7] = { 192, 192, 3, 4, spellLevel = 56, maxLevel = 59, Downrank = 4, },
						[8] = { 230, 230, 4, 4, spellLevel = 60, maxLevel = 62, Downrank = 5, },
						[9] = { 240, 240, 3, 4, spellLevel = 63, maxLevel = 68, Downrank = 2, },
						[10] = { 263, 264, 4, 5, spellLevel = 69, maxLevel = 70, }, --Blizzard tooltip reports wrong basedamage (real is +3,4)
						[11] = { 280, 280, 0, 0, spellLevel = 70, maxLevel = 70, },
			},
			[BS["Arcane Explosion"]] = {
						[0] = { School = "Arcane", Instant = true, canCrit = true, sFactor = 1/2, BaseIncrease = true, },
						[1] = { 32, 36, 2, 2,  spellLevel = 14, maxLevel = 21, },
						[2] = { 57, 63, 3, 3, spellLevel = 22, maxLevel = 29, },
						[3] = { 97, 105, 4, 5, spellLevel = 30, maxLevel = 37, },
						[4] = { 139, 151, 4, 5, spellLevel = 38, maxLevel = 45, },
						[5] = { 186, 202, 5, 6, spellLevel = 46, maxLevel = 53, },
						[6] = { 243, 263, 6, 7, spellLevel = 54, maxLevel = 61, },
						[7] = { 306, 330, 7, 8, spellLevel = 62, maxLevel = 69, },
						[8] = { 377, 407, 0, 0, spellLevel = 70, maxLevel = 70, },
			},
			[BS["Arcane Blast"]] = {
						[0] = { School = "Arcane", canCrit = true, castTime = 2.5, BaseIncrease = true, },
						[1] = { 648, 752, 20, 20, spellLevel = 64, maxLevel = 70, },
			},
			[BS["Gift of the Naaru"]] = {
						[0] = { School = { "Holy", "Healing" }, Cooldown = 180, castTime = 1.5, eDot = true, eDuration = 15, sTicks = 3, bonusFactor = 1, BaseIncrease = true, NoLowLevelPenalty = true, },
						["None"] = { 35, 35, 1050, 1050, spellLevel = 0, maxLevel = 70, },
			},
		},

		talentInfo = { 
			--ARCANE:
			--All
			["Arcane Instability"] = { Effect = 0.01, Spells = { "All" }, },
			["Spell Power"] = { Effect = 0.125, Spells = { "All" }, ModType = "CritMultiplier", },
			--Spell specific
			["Arcane Focus"] = { Effect = 2, Spells = { "Arcane" }, ModType = "Hit", },
			["Arcane Impact"] = { Effect = 2, Spells = { "Arcane Explosion", "Arcane Blast" }, ModType = "Crit", },
			["Empowered Arcane Missiles"] = { Effect = 0.15, Spells = { "Arcane Missiles" }, ModType = "SpellDamage", },
			--FIRE:
			--All/School specific:
			["Master of Elements"] = { Effect = 0.1, Spells = { "All" }, ModType = "FreeCrit" },
			["Playing with Fire"] = { Effect = 0.01, Spells = { "All" }, },			
			["Ignite"] = { Effect = 0.08, Spells = { "Fire" }, ModType = "Ignite", },		
			["Fire Power"] = { Effect = 0.02, Spells = { "Fire" }, },			
			--Spell specific
			["Improved Fireball"] = { Effect = 1, Spells = { "Fireball" }, ModType = "CastTime" },
			["Empowered Fireball"] = { Effect = 0.03, Spells = { "Fireball" }, ModType = "SpellDamage", },
			["Incineration"] = { Effect = 2, Spells = { "Fire Blast", "Scorch", }, ModType = "Crit", },
			["Improved Flamestrike"] = { Effect = 5, Spells = { "Flamestrike" }, ModType = "Crit", },
			["Improved Fire Blast"] = { Effect = 0.5, Spells = { "Fire Blast" }, ModType = "Cooldown", },
			--FROST:
			["Elemental Precision"] = { Effect = 1, Spells = { "Frost", "Fire" }, ModType = "Hit" },
			["Improved Frostbolt"] = { Effect = 1, Spells = { "Frostbolt" }, ModType = "CastTime" },
			["Ice Shards"] = { Effect = 0.10, Spells = { "Frost" }, ModType = "CritMultiplier", },
			["Shatter"] = { Effect = 1, Spells = { "All" }, ModType = "Shatter" },
			["Piercing Ice"] = { Effect = 0.02, Spells = { "Frost" }, },
			["Improved Cone of Cold"] = { Effect = { 0.15, 0.25, 0.35, }, Spells = { "Cone of Cold" }, },
			["Empowered Frostbolt"] = { Effect = 0.02, Spells = { "Frostbolt" }, ModType = "SpellDamage", Effect2 = 1, Spells2 = { "Frostbolt" }, ModType2 = "Crit" }, 
			["Arctic Winds"] = { Effect = 0.01, Spells = { "Frost" }, },
			
			--IGNORE BELOW: Only added due to translation issues, BabbleSpell will translate Incineration into Combustion due to identical names in German clients.
			["Incinerate"] = { Locale = "koKR", Effect = 2, Spells = { "Fire Blast", "Scorch", }, ModType = "Crit", },
			["Combustion"] = { Locale = "deDE", Effect = 2, Spells = { "Fire Blast", "Scorch", }, ModType = "Crit", },
		},
	}
	
	return MageTable["spellInfo"], MageTable["talentInfo"]
end