local BS = AceLibrary("Babble-Spell-2.2");

--No base increase: Avenger's Shield, Holy Shield, Consecration, Holy Wrath

function DrDamage:PaladinData()

	local PaladinTable = {

		spellInfo = { 
			[BS["Crusader Strike"]] = { 
						[0] = { School = { "Holy", "Physical" }, bonusFactor = 0.4, Cooldown = 10, NoNext = true, NoSchoolBuffs = true },
						["None"] = { 0, 0, spellLevel = 50, },
						[1] = { 0, 0, spellLevel = 50, },
			},
			[BS["Avenger's Shield"]] = { 
						[0] = { School = { "Holy", "Physical" }, canCrit = true, castTime = 1, sFactor = 1/2, chainFactor = 1, Downrank = -2, Cooldown = 30, },
						[1] = { 270, 330, spellLevel = 50, maxLevel = 59, },
						[2] = { 370, 452, spellLevel = 60, maxLevel = 69, }, 
						[3] = { 494, 602, spellLevel = 70, maxLevel = 70, }, 
			},
			[BS["Holy Wrath"]] = { 
						[0] = { School = "Holy", canCrit = true, castTime = 2, sFactor = 1/2, Downrank = -2, BaseIncrease = true, },
						[1] = { 362, 428, 6, 7, spellLevel = 50, maxLevel = 59, },
						[2] = { 490, 576, 7, 8, spellLevel = 60, maxLevel = 68, },
						[3] = { 635, 745, 2, 3, spellLevel = 69, maxLevel = 70, },
			},
			[BS["Holy Shield"]] = { 
						[0] = { School = "Holy", Instant = true, bonusFactor = 0.20, NoDPS = true, NoDoom = true, sHits = 4, },
						[1] = { 59, 59, spellLevel = 40, },
						[2] = { 86, 86, spellLevel = 50, },
						[3] = { 117, 117, spellLevel = 60, },
						[4] = { 155, 155, spellLevel = 70, },
			},
			[BS["Holy Light"]] = { 
						[0] = { School = { "Holy", "Healing" }, canCrit = true, castTime = 2.5, Downrank = -2, BaseIncrease = true, },
						[1] = { 39, 47, 3, 4, spellLevel = 1, maxLevel = 5, Downrank = 2, },
						[2] = { 76, 90, 5, 6, spellLevel = 6, maxLevel = 13, },
						[3] = { 159, 187, 8, 9, spellLevel = 14, maxLevel = 21, },
						[4] = { 310, 356, 12, 12, spellLevel = 22, maxLevel = 29, },
						[5] = { 491, 553, 15, 16, spellLevel = 30, maxLevel = 37, },
						[6] = { 698, 780, 19, 19, spellLevel = 38, maxLevel = 45, },
						[7] = { 945, 1053, 23, 23, spellLevel = 46, maxLevel = 53, },
						[8] = { 1246, 1388, 26, 26, spellLevel = 54, maxLevel = 59, },
						[9] = { 1590, 1770, 29, 29, spellLevel = 60, maxLevel = 61, },
						[10] = { 1741, 1939, 32, 32, spellLevel = 62, maxLevel = 69, },
						[11] = { 2196, 2446, 0, 0, spellLevel = 70, maxLevel = 70, },
			},	
			[BS["Hammer of Wrath"]] = {
						[0] = { School = { "Holy", "Physical" }, canCrit = true, Cooldown = 6, BaseIncrease = true, },
						[1] = { 304, 336, 12, 12, spellLevel = 44, maxLevel = 51, },
						[2] = { 399, 441, 13, 14, spellLevel = 52, maxLevel = 59, },
						[3] = { 504, 556, 15, 16, spellLevel = 60, maxLevel = 67, },
						[4] = { 665, 735, 7, 7, spellLevel = 68, maxLevel = 70, }, --Check increase
			},
			[BS["Exorcism"]] = {
						[0] = { School = "Holy", Instant = true, canCrit = true, Cooldown = 15, BaseIncrease = true, },
						[1] = { 84, 96, 6, 6, spellLevel = 20, maxLevel = 27, },
						[2] = { 152, 172, 8, 8, spellLevel = 28, maxLevel = 35, },
						[3] = { 217, 245, 10, 10, spellLevel = 36, maxLevel = 43, },
						[4] = { 304, 342, 12, 12, spellLevel = 44, maxLevel = 51, },
						[5] = { 393, 439, 14, 14, spellLevel = 52, maxLevel = 59, },
						[6] = { 505, 563, 16, 16, spellLevel = 60, maxLevel = 67, },
						[7] = { 619, 691, 7, 7, spellLevel = 68, maxLevel = 70, },
			},
			[BS["Consecration"]] = {
						--sFactor = 1/2 * 0.83?
						[0] = { School = "Holy", castTime = 8, sFactor = 1/3, sTicks = 1, Downrank = -2, },
						[1] = { 64, 64, spellLevel = 20, maxLevel = 29, },
						[2] = { 120, 120, spellLevel = 30, maxLevel = 39, },
						[3] = { 192, 192, spellLevel = 40, maxLevel = 49, },
						[4] = { 280, 280, spellLevel = 50, maxLevel = 59, },
						[5] = { 384, 384, spellLevel = 60, maxLevel = 69, },
						[6] = { 512, 512, spellLevel = 70, maxLevel = 70, },
			},
			[BS["Flash of Light"]] = { 
						[0] = { School = { "Holy", "Healing" }, canCrit = true, castTime = 1.5, Downrank = -2, BaseIncrease = true },
						[1] = { 62, 72, 5, 5, spellLevel = 20, maxLevel = 25, Downrank = 0, },
						[2] = { 96, 110, 6, 7, spellLevel = 26, maxLevel = 33, },
						[3] = { 145, 163, 8, 9, spellLevel = 34, maxLevel = 41, },
						[4] = { 197, 221, 9, 10, spellLevel = 42, maxLevel = 49, },
						[5] = { 267, 299, 11, 11, spellLevel = 50, maxLevel = 57, },
						[6] = { 343, 383, 13, 13, spellLevel = 58, maxLevel = 65, },
						[7] = { 448, 502, 10, 11, spellLevel = 66, maxLevel = 70, },
			},
			[BS["Holy Shock"]] = { 
						[0] = { School = "Holy", Instant = true, canCrit = true, Cooldown = 15, },
						[1] = { 204, 220, spellLevel = 40, maxLevel = 47, },
						[2] = { 279, 301, spellLevel = 48, maxLevel = 55, },
						[3] = { 365, 395, spellLevel = 56, maxLevel = 63, },
						[4] = { 452, 488, spellLevel = 64, maxLevel = 69, Downrank = 2 },
						[5] = { 530, 574, spellLevel = 70, maxLevel = 70, },
			},
			--Judgements:
			[BS["Seal of Righteousness"]] = {
						[0] = { School = { "Holy", "Judgement" }, Instant = true, bonusFactor = 0.73, canCrit = true, NoDPM = true, NoDoom = true, NoNext = true, BaseIncrease = true, },
						[1] = { 15, 15, 10, 11, spellLevel = 1, maxLevel = 9, },
						[2] = { 25, 27, 11, 12, spellLevel = 10, maxLevel = 17, },
						[3] = { 39, 43, 14, 15, spellLevel = 18, maxLevel = 25, },
						[4] = { 57, 63, 16, 17, spellLevel = 26, maxLevel = 33, },
						[5] = { 78, 86, 18, 19, spellLevel = 34, maxLevel = 41, },
						[6] = { 102, 112, 22, 23, spellLevel = 42, maxLevel = 49, },	
						[7] = { 131, 143, 24, 25, spellLevel = 50, maxLevel = 57, },
						[8] = { 162, 178, 24, 25, spellLevel = 58, maxLevel = 65, },
						[9] = { 208, 228, 17, 18, spellLevel = 66, maxLevel = 70, }, 
			},
			[BS["Seal of Command"]] = {
						[0] = { School = { "Holy", "Judgement", "Physical" }, Instant = true, canCrit = true, Downrank = -2, NoDPM = true, NoDoom = true, NoNext = true, BaseIncrease = true, },
						[1] = { 46, 50, 22, 23, spellLevel = 20, maxLevel = 29, },
						[2] = { 73, 80, 24, 25, spellLevel = 30, maxLevel = 39, },
						[3] = { 102, 112, 22, 23, spellLevel = 40, maxLevel = 49, },
						[4] = { 130, 143, 24, 25, spellLevel = 50, maxLevel = 59, },
						[5] = { 169, 186, 24, 25, spellLevel = 60, maxLevel = 69, },
						[6] = { 228, 252, 0, 0, spellLevel = 70, maxLevel = 70, },
			},
			[BS["Seal of Vengeance"]] = {
						[0] = { School = { "Holy", "Judgement" }, Instant = true, canCrit = true, NoDPM = true, NoDoom = true, NoNext = true, },
						[1] = { 120, 120, spellLevel = 64, maxLevel = 70, },			
			},
			[BS["Seal of Blood"]] = {
						[0] = { School = { "Holy", "Judgement" }, Instant = true, canCrit = true, NoDPM = true, NoDoom = true, NoNext = true, BaseIncrease = true, },
						[1] = { 295, 325, 36, 37, spellLevel = 64, maxLevel = 70, },			
			},
			[BS["Gift of the Naaru"]] = {
						[0] = { School = { "Holy", "Healing" }, Cooldown = 180, castTime = 1.5, eDot = true, eDuration = 15, sTicks = 3, bonusFactor = 1, BaseIncrease = true, NoLowLevelPenalty = true, },
						["None"] = { 35, 35, 1050, 1050, spellLevel = 0, maxLevel = 70, },
			},			
		},

		talentInfo = { 
			--Holy:
			["Improved Seal of Righteousness"] = { Effect = 0.03, Spells = { "Seal of Righteousness", }, },
			["Healing Light"] = { Effect = 0.04, Spells = { "Holy Light", "Flash of Light", }, },
			["Sanctified Light"] = { Effect = 2, Spells = { "Holy Light", }, ModType = "Crit" },
			["Improved Seal of the Crusader"] = { Effect = 1, Spells = { "Holy" }, ModType = "BuffTalentRank2" }, --Improves judgement of the crusader
			["Illumination"] = { Effect = 0.12, Spells = { "Holy Light", "Flash of Light", "Holy Shock" }, ModType = "FreeCrit" },
			["Purifying Power"] = { Effect = 10, Spells = { "Holy Wrath", "Exorcism", }, ModType = "Crit" },
			--Retribution:
			["Crusade"] = { Effect = 0.01, Spells = { "All" }, ModType = "Crusade" },
			["Vengeance"] = { Effect = 1, Spells = { "Holy" }, ModType = "BuffTalentRank", }, --Rank for buff vengeance
			["Sanctified Crusader"] = { Effect = 1, Spells = { "All" }, ModType = "BuffTalentRank3" }, --Judgement of the crusader also adds 1-3% crit
			["Improved Sanctity Aura"] = { Effect = 1, Spells = { "All" }, ModType = "ImpSanctity" },
			["Fanaticism"] = { Effect = 3, Spells = { "Judgement" }, ModType = "Crit" },
			
			["Improved Holy Shield"] = { Effect = 0.1, Spells = { "Holy Shield" }, Effect2 = 2, Spells2 = { "Holy Shield" }, ModType = "Hits" },
			["One-Handed Weapon Specialization"] = { Effect = 0.01, Spells = { "All" }, ModType = "OneHanded" },
		},
	}
	
	return PaladinTable["spellInfo"], PaladinTable["talentInfo"]
end